﻿using System;
using System.ServiceModel;
using DistributedGA.Core.Domain;
using DistributedGA.Core.Interface;

namespace DistributedGA.Core.Implementation {
  public class WcfMessageSender : IMessageSender {
    private PeerInfo myself;

    public void Init(PeerInfo source) {
      myself = source;
    }

    public void SendData(PeerInfo destination, byte[][] data) {

      var serviceUrl = "DistributedGA.svc";
      var baseUri = new Uri(string.Concat("net.tcp://", destination.IpAddress, ":", destination.Port, "/DistributedGA"));
      var serviceUri = new Uri(baseUri, serviceUrl);

      var binding = new NetTcpBinding();
      var endpoint = new EndpointAddress(serviceUri);
      using (var myChannelFactory = new ChannelFactory<IMessageContract>(binding, endpoint)) {
        using (IClientChannel client = (IClientChannel)myChannelFactory.CreateChannel()) {
          ((IMessageContract)client).SendData(myself, data); //maybe timout exception...
        }
      }
    }

    public void Dispose() {

    }
  }
}
